window.Gleam.initSearch([{"doc":"react_gleam","title":"react_gleam","content":"# react_gleam\n\nReact bindings for Gleam inspired by [Lustre](https://github.com/hayleigh-dot-dev/gleam-lustre/blob/main/src/lustre/attribute.gleam) and [ReasonReact](https://reasonml.github.io/reason-react/).\n\n---\n\n```gleam\nimport gleam/int\nimport react_gleam.{render}\nimport react_gleam/element.{Element, component, div, h1}\nimport react_gleam/hooks.{use_state}\nimport react_gleam/event.{on_click}\n\npub fn main() {\n  render(app)\n}\n\nfn app() -&gt; Element {\n  div([], [\n    h1([], [text(&quot;Welcome to Gleam React!&quot;)]),\n    greet(name: &quot;Joe&quot;),\n    counter(count: 6)\n  ])\n}\n\nfn greet(name name: String) -&gt; Element {\n  div([], [text(&quot;Hello &quot; &lt;&gt; name &lt;&gt; &quot;!&quot;)])\n}\n\nfn counter(count init_count: Int) -&gt; Element {\n  use &lt;- component()\n\n  let #(count, set_count) = use_state(init_count)\n\n  div([], [\n    div(\n      [on_click(fn(_) { set_count(count + 1) })], \n      [text(&quot;+&quot;)]),\n    div(\n      [], \n      [int.to_string(count)]),\n    div(\n      [on_click(fn(_) { set_count(count - 1) })], \n      [text(&quot;-&quot;)]),\n  ])\n}\n```\n\n## Installation\n\nIf available on Hex this package can be added to your Gleam project:\n\n```sh\ngleam add react_gleam\n\nyarn add react react-dom\n```\n","url":"index.html"},{"doc":"react_gleam/attribute","title":"Attribute","content":"pub opaque type Attribute(action)\n\n\nSynonyms:\nreact_gleam/attribute.Attribute\nreact_gleam/attribute Attribute","url":"react_gleam/attribute.html#Attribute"},{"doc":"react_gleam/attribute","title":"attribute","content":"pub fn attribute(name: String, value: String) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/attribute.attribute\nreact_gleam/attribute attribute","url":"react_gleam/attribute.html#attribute"},{"doc":"react_gleam/attribute","title":"event","content":"pub fn event(name: String, handler: fn(Dynamic, fn(a) -&gt; Nil) -&gt;\n    Nil) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/attribute.event\nreact_gleam/attribute event","url":"react_gleam/attribute.html#event"},{"doc":"react_gleam/attribute","title":"property","content":"pub fn property(name: String, value: Dynamic) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/attribute.property\nreact_gleam/attribute property","url":"react_gleam/attribute.html#property"},{"doc":"react_gleam/attribute","title":"react_gleam/attribute","content":"","url":"react_gleam/attribute.html"},{"doc":"react_gleam/element","title":"Element","content":"pub external type Element\n\n\nSynonyms:\nreact_gleam/element.Element\nreact_gleam/element Element","url":"react_gleam/element.html#Element"},{"doc":"react_gleam/element","title":"component","content":"pub external fn component(element: fn() -&gt; Element) -&gt; Element\n\nSynonyms:\nreact_gleam/element.component\nreact_gleam/element component","url":"react_gleam/element.html#component"},{"doc":"react_gleam/element","title":"div","content":"pub fn div(attributes: List(Attribute(a)), children: List(Element)) -&gt; Element\n\nSynonyms:\nreact_gleam/element.div\nreact_gleam/element div","url":"react_gleam/element.html#div"},{"doc":"react_gleam/element","title":"node","content":"pub external fn node(\n  tag: String,\n  attributes: List(Attribute(action)),\n  children: List(Element),\n) -&gt; Element\n\nSynonyms:\nreact_gleam/element.node\nreact_gleam/element node","url":"react_gleam/element.html#node"},{"doc":"react_gleam/element","title":"text","content":"pub external fn text(content: String) -&gt; Element\n\nSynonyms:\nreact_gleam/element.text\nreact_gleam/element text","url":"react_gleam/element.html#text"},{"doc":"react_gleam/element","title":"react_gleam/element","content":"","url":"react_gleam/element.html"},{"doc":"react_gleam/hooks","title":"use_effect","content":"pub external fn use_effect(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect\nreact_gleam/hooks use_effect","url":"react_gleam/hooks.html#use_effect"},{"doc":"react_gleam/hooks","title":"use_effect0","content":"pub external fn use_effect0(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect0\nreact_gleam/hooks use_effect0","url":"react_gleam/hooks.html#use_effect0"},{"doc":"react_gleam/hooks","title":"use_effect1","content":"pub external fn use_effect1(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect1\nreact_gleam/hooks use_effect1","url":"react_gleam/hooks.html#use_effect1"},{"doc":"react_gleam/hooks","title":"use_effect2","content":"pub external fn use_effect2(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g, l),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect2\nreact_gleam/hooks use_effect2","url":"react_gleam/hooks.html#use_effect2"},{"doc":"react_gleam/hooks","title":"use_effect3","content":"pub external fn use_effect3(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g, l, e),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect3\nreact_gleam/hooks use_effect3","url":"react_gleam/hooks.html#use_effect3"},{"doc":"react_gleam/hooks","title":"use_effect4","content":"pub external fn use_effect4(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g, l, e, a),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect4\nreact_gleam/hooks use_effect4","url":"react_gleam/hooks.html#use_effect4"},{"doc":"react_gleam/hooks","title":"use_effect5","content":"pub external fn use_effect5(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g, l, e, a, m),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect5\nreact_gleam/hooks use_effect5","url":"react_gleam/hooks.html#use_effect5"},{"doc":"react_gleam/hooks","title":"use_effect6","content":"pub external fn use_effect6(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g, l, e, a, m, o),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect6\nreact_gleam/hooks use_effect6","url":"react_gleam/hooks.html#use_effect6"},{"doc":"react_gleam/hooks","title":"use_effect7","content":"pub external fn use_effect7(\n  cb: fn() -&gt; Option(fn() -&gt; Nil),\n  props: #(g, l, e, a, m, o, r),\n) -&gt; Nil\n\nSynonyms:\nreact_gleam/hooks.use_effect7\nreact_gleam/hooks use_effect7","url":"react_gleam/hooks.html#use_effect7"},{"doc":"react_gleam/hooks","title":"use_reducer","content":"pub external fn use_reducer(\n  fn(a, b) -&gt; a,\n  init: a,\n) -&gt; #(a, fn(b) -&gt; Nil)\n\nSynonyms:\nreact_gleam/hooks.use_reducer\nreact_gleam/hooks use_reducer","url":"react_gleam/hooks.html#use_reducer"},{"doc":"react_gleam/hooks","title":"use_state","content":"pub external fn use_state(init: a) -&gt; #(a, fn(a) -&gt; Nil)\n\nSynonyms:\nreact_gleam/hooks.use_state\nreact_gleam/hooks use_state","url":"react_gleam/hooks.html#use_state"},{"doc":"react_gleam/hooks","title":"react_gleam/hooks","content":"","url":"react_gleam/hooks.html"},{"doc":"react_gleam","title":"render","content":"pub external fn render(app: Element, root: String) -&gt; Nil\n\nSynonyms:\nreact_gleam.render\nreact_gleam render","url":"react_gleam.html#render"},{"doc":"react_gleam","title":"react_gleam","content":"","url":"react_gleam.html"},{"doc":"react_gleam/event","title":"dispatch","content":"pub fn dispatch(action: a) -&gt; fn(fn(a) -&gt; Nil) -&gt; Nil\n\nSynonyms:\nreact_gleam/event.dispatch\nreact_gleam/event dispatch","url":"react_gleam/event.html#dispatch"},{"doc":"react_gleam/event","title":"on","content":"pub fn on(name: String, handler: fn(Dynamic, fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on\nreact_gleam/event on","url":"react_gleam/event.html#on"},{"doc":"react_gleam/event","title":"on_blur","content":"pub fn on_blur(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/event.on_blur\nreact_gleam/event on_blur","url":"react_gleam/event.html#on_blur"},{"doc":"react_gleam/event","title":"on_check","content":"pub fn on_check(handler: fn(Bool, fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_check\nreact_gleam/event on_check","url":"react_gleam/event.html#on_check"},{"doc":"react_gleam/event","title":"on_click","content":"pub fn on_click(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/event.on_click\nreact_gleam/event on_click","url":"react_gleam/event.html#on_click"},{"doc":"react_gleam/event","title":"on_focus","content":"pub fn on_focus(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/event.on_focus\nreact_gleam/event on_focus","url":"react_gleam/event.html#on_focus"},{"doc":"react_gleam/event","title":"on_input","content":"pub fn on_input(handler: fn(String, fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_input\nreact_gleam/event on_input","url":"react_gleam/event.html#on_input"},{"doc":"react_gleam/event","title":"on_keydown","content":"pub fn on_keydown(handler: fn(String, fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_keydown\nreact_gleam/event on_keydown","url":"react_gleam/event.html#on_keydown"},{"doc":"react_gleam/event","title":"on_keypress","content":"pub fn on_keypress(handler: fn(String, fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_keypress\nreact_gleam/event on_keypress","url":"react_gleam/event.html#on_keypress"},{"doc":"react_gleam/event","title":"on_keyup","content":"pub fn on_keyup(handler: fn(String, fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_keyup\nreact_gleam/event on_keyup","url":"react_gleam/event.html#on_keyup"},{"doc":"react_gleam/event","title":"on_mouse_down","content":"pub fn on_mouse_down(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_mouse_down\nreact_gleam/event on_mouse_down","url":"react_gleam/event.html#on_mouse_down"},{"doc":"react_gleam/event","title":"on_mouse_enter","content":"pub fn on_mouse_enter(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_mouse_enter\nreact_gleam/event on_mouse_enter","url":"react_gleam/event.html#on_mouse_enter"},{"doc":"react_gleam/event","title":"on_mouse_leave","content":"pub fn on_mouse_leave(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_mouse_leave\nreact_gleam/event on_mouse_leave","url":"react_gleam/event.html#on_mouse_leave"},{"doc":"react_gleam/event","title":"on_mouse_out","content":"pub fn on_mouse_out(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_mouse_out\nreact_gleam/event on_mouse_out","url":"react_gleam/event.html#on_mouse_out"},{"doc":"react_gleam/event","title":"on_mouse_over","content":"pub fn on_mouse_over(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_mouse_over\nreact_gleam/event on_mouse_over","url":"react_gleam/event.html#on_mouse_over"},{"doc":"react_gleam/event","title":"on_mouse_up","content":"pub fn on_mouse_up(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(\n  a,\n)\n\nSynonyms:\nreact_gleam/event.on_mouse_up\nreact_gleam/event on_mouse_up","url":"react_gleam/event.html#on_mouse_up"},{"doc":"react_gleam/event","title":"on_submit","content":"pub fn on_submit(handler: fn(fn(a) -&gt; Nil) -&gt; Nil) -&gt; Attribute(a)\n\nSynonyms:\nreact_gleam/event.on_submit\nreact_gleam/event on_submit","url":"react_gleam/event.html#on_submit"},{"doc":"react_gleam/event","title":"react_gleam/event","content":"","url":"react_gleam/event.html"}]);